=== debian/changelog ===
blender (2.62-1) unstable; urgency=low

  * New upstream release (Closes: #661063)
    + debian/patches: #0002 dropped (applied upstream)
    + debian/patches: #0010 dropped (applied upstream)
    + debian/patches: #0012 dropped (applied upstream)
    + debian/patches: #0013 dropped (applied upstream)
  * debian/control: libglew-dev b-deps fixed
  * debian/control: libboost-dev added to b-deps
  * debian/control: Standards-Version bumped to 3.9.3
  * debian/rules: Ocean Sim support added (Closes: #659442)

 -- Matteo F. Vescovi <mfv.debian@gmail.com>  Mon, 12 Mar 2012 19:04:53 +0100
